'*************************************************************************************************
'Software Engineer: Roger A. Mir
'Company: CDC
'Date: 07/12/2007
'**************************************************************************************************

'This program reads and writes file(s) from and to a specified folder
On Error Resume Next  
Dim objFS, Folder_name, colFiles, NewsFile, strFolder, oLogFile, oTSMergeSetupFile, sFlag    
Dim sLine ' array of strings
Dim aTables()
ReDim aTables(1)
Set objFS = CreateObject("Scripting.FileSystemObject")  

'strFolder = Wscript.Arguments.Item(0)  
strFolder="%PATH_MERGE_TOOL%"
If IsEmpty(strFolder) Then      
	Wscript.Echo "Sorry! no folder name/parameter was passed!"      
	Wscript.Quit  
End If  
sFlag = False
Set NewFile = objFS.CreateTextFile(strFolder & "Temp" & "\MERGE_DATA.PGM", True)  

If objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") Then
		Set oLogFile=objFS.OpenTextFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt", 8) ' 8=IOMode for appending 
Else
		Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt", True)  
End If
		
Set Folder_name = objFS.GetFolder("%PATH_MERGE_UNZIP_FILES%")  
Set colFiles = Folder_name.Files    

Set oTSMergeSetupFile = objFS.OpenTextFile(strFolder & "Temp\" & "MERGE_SETUP.TXT", 1)  ' 1 = IOMode.ForReading
i=0
Do While Not oTSMergeSetupFile.AtEndOfStream         
    sLine = Split(oTSMergeSetupFile.ReadLine(), "|")
    If Trim(sLine(0))="" Then
    	Exit Do
    End If
    aTables(i)=Trim(sLine(2))
    i=i+1  
    ReDim Preserve aTables(i) 
'    oLogFile.WriteLine(" - " & Trim(sLine(1)))
Loop

' reset the pointer to top of the file
oTSMergeSetupFile.Close  
Set oTSMergeSetupFile = Nothing

NewFile.WriteLine("SET HYPERLINKS=(+) PERCENTS=(+) SHOWPROMPTS=(+) SELECT=(+) FREQGRAPH=(+) TABLES=(+) STATISTICS=NONE")
NewFile.WriteLine("****")
bTableHeader=False
For each folderIdx In colFiles
	  If UCase(Right(folderIdx.Name,3))= "MDB" Then  			
	  	
				Set oTSMergeSetupFile = objFS.OpenTextFile(strFolder & "Temp\" & "MERGE_SETUP.TXT", 1)  ' 1 = IOMode.ForReading
'				oTSMergeSetupFile.Open	  	
'        oLogFile.WriteLine(" - " & folderIdx.Name)

				If not bTableHeader Then
						oLogFile.WriteLine("")
						oLogFile.WriteLine("")
						oLogFile.WriteLine("Date:" & Now())   
						oLogFile.WriteLine("======= Below is a list of tables and databases that have been processed =======")   	
						bTableHeader=True
			  End If
				For i=0 to UBound(aTables) - 1
						oLogFile.WriteLine("Database Name :" & folderIdx.Name & ", " & "Processed table name :" & aTables(i) )
				Next
						oLogFile.WriteLine("")
        Do While Not oTSMergeSetupFile.AtEndOfStream 
            sLine = Split(oTSMergeSetupFile.ReadLine(), "|")
               
            NewFile.WriteLine("READ " & "'" & Trim(sLine(0)) & "':" & Trim(sLine(1)))
            NewFile.WriteLine("MERGE " & "'" & "%PATH_MERGE_UNZIP_FILES%" & folderIdx.Name & "':" & Trim(sLine(2)) & " " & Trim(sLine(3)))
        Loop
        NewFile.WriteLine("****")  
        oTSMergeSetupFile.Close	
        Set oTSMergeSetupFile = Nothing  	
        sFlag = True
		End If
		
Next  
If sFlag= True Then
		NewFile.WriteLine("ASSIGN MERGE_FLAG=" & """" & "T" & """")		
Else
		NewFile.WriteLine("ASSIGN MERGE_FLAG=" & """" & "F" & """")		
End If 
NewFile.WriteLine("QUIT")
NewFile.WriteLine("")

NewFile.Close
oLogFile.Close
Folder_name.Close
colFiles.Close
oTSMergeSetupFile.Close
Set NewFile = Nothing
Set oLogFile = Nothing
Set Folder_name = Nothing
Set colFiles = Nothing
Set oTSMergeSetupFile = Nothing
Wscript.Quit