Dim objTable, objFS, objFile, objTableName, bMissingTableMDB, objMDB,oLogFile, strFolder, nIndex, oTSMergeSetupFile, sLine, i, j, Folder_name, colFiles, bFound
Dim amTables(), aDatabase(), sTemp

strFolder="C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\"

On Error Resume Next
Set objFS = CreateObject("Scripting.FileSystemObject")  

Sub ReadSetupFile()
		'Read merge setup file to retrive table name for external file
		If objFS.FileExists(strFolder & "Temp\" & "MERGE_SETUP.TXT") Then
				Set oTSMergeSetupFile = objFS.OpenTextFile(strFolder & "Temp\" & "MERGE_SETUP.TXT", 1)  ' 1 = IOMode.ForReading
		Else
				MsgBox "...Temp\MERGE_SETUP.TXT file does not exist!",16 
				Set objFS = Nothing
				Wscript.Quit
		End If
End Sub

'Count number of lines in the setup file for redefine the array elements
i=0
Call ReadSetupFile			'call the sub for reading the setup file
Do While Not oTSMergeSetupFile.AtEndOfStream  
	sLine = oTSMergeSetupFile.ReadLine() 
	If Trim(sLine)="" Then
		Exit Do
	End If
	i = i+1
Loop
ReDim amTables(i,2)			'Redefine an array

oTSMergeSetupFile.Close	'Close open file
Call ReadSetupFile 			'call the sub for reading the setup file
i=0
Do While Not oTSMergeSetupFile.AtEndOfStream   
    sLine = Split(oTSMergeSetupFile.ReadLine(), "|")    
    If Trim(sLine(0)) ="" Then
    	Exit Do
    End If
    amTables(i,0)=Trim(sLine(0))
    amTables(i,1)=Trim(sLine(1))
    amTables(i,2)=Trim(sLine(2))
    i=i+1  
Loop


'Log file for missing master database and tables	
If objFS.FileExists(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt") Then
		Set objFile=objFS.GetFile(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt")
		objFile.Delete()
End If

'Check for existence of master database
For i=0 to UBound(amTables) -1
		If not objFS.FileExists(amTables(i,0)) Then
				MsgBox "Missing master database! " & amTables(i,0), 16, "Master database"
				Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt", True)
				oLogFile.WriteLine("Missing Master Database Name :" & amTables(i,0))
				Wscript.Quit
		End If
Next 


'************************************************************************************************
'Check for missing table, defined in the merge setup file, in the Master database
'************************************************************************************************


'Check the log file for master database missing tables
'if found then delete the log file
If objFS.FileExists(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt") Then
		Set objFile=objFS.GetFile(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt")
		objFile.Delete()
End If

'Log file for merged database and tables	
If objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") Then
		Set objFile=objFS.GetFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt")
		objFile.Delete()
End If

	
bFound=False
bMissingTableMDB=False
	
Set appAccess = WScript.CreateObject("Access.Application")
appAccess.Visible = False
appAccess.automationsecurity=1	'set macro security LOW
Function objMasterDatabaseTable(i)
		appAccess.OpenCurrentDatabase (amTables(i,0))	
		Set objMasterDatabaseTable = appAccess.CurrentData.AllTables
End Function


'**************************************************************************
'	Read master database
'	Check for necessary tables in the database
'**************************************************************************

Set objTable = objMasterDatabaseTable(0)	'read master database and tables

For i=0 to UBound(amTables) - 1
	bFound=False

	If i > 0 Then 
		If UCase(amTables(i-1,0)) <> UCase(amTables(i,0)) Then			
			appAccess.CloseCurrentDatabase						'Close currently open database
			Set objTable = objMasterDatabaseTable(i)	'read another master database and tables
		End If
	End If

	For each objTableName In objTable
			If UCase(amTables(i,1)) = UCase(objTableName.Name) Then
					bFound=True			
					Exit For				 
			End If		
	Next
	
	If Not objFS.FileExists(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt") and not bFound Then
			Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt", True)
			oLogFile.WriteLine("")
			oLogFile.WriteLine("Missing master database table information" & ", " & "Date :" & Now())
			oLogFile.WriteLine("==================================================================================")				
	End If
	
	If not bFound Then
			oLogFile.WriteLine("Database Name :" & amTables(i,0) & ", " & "Missing table name :" & amTables(i,1))
			bMissingTableMDB=True							
	End If				

Next 
	
'Close currently open database
appAccess.CloseCurrentDatabase

'If master database does not have all the necessary tables then stop the merge process
If bMissingTableMDB=True Then
		MsgBox "Master database does not have all necessary tables to perform merge process!  Please check the log file for detail information," & strFolder & "Temp\LOG_MASTER_MISSING_TABLE.txt",16,"Missing table in the master database"
		Wscript.Quit
End If

'*************************************************************************************************


ReDim aDatabase(1)		
j=0
bFound=False
bMissingTableMDB=False
Set Folder_name = objFS.GetFolder("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\Unzip_files\")  
Set colFiles = Folder_name.Files 

For each objMDB In colFiles		
		'Read the database
		appAccess.OpenCurrentDatabase (objMDB)

		'Read all tables from external database
		Set objTable = appAccess.CurrentData.AllTables

		For i=0 to UBound(amTables) - 1
				
				For each objTableName In objTable	
						If UCase(amTables(i,2)) = UCase(objTableName.Name) Then
								bFound=True
								Exit For		
						End If		
				Next
				
				'Using this file just for file flag information
				If Not objFS.FileExists(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt") and not bFound Then
						Set oLogFile1 = objFS.CreateTextFile(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt") 
						oLogFile1.WriteLine("")
						oLogFile1.WriteLine("Date & Time :" & Now())			
						oLogFile1.WriteLine("Just using as a flag")
						oLogFile1.WriteLine("===============================================================================")		
						oLogFile1.clsoe	
				End If	
				
				If not objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") Then
					If not bFound Then					
						Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt") 
						oLogFile.WriteLine("")
						oLogFile.WriteLine("Date :" & Now())			
						oLogFile.WriteLine("Below is a list of databases that have not been processed due to missing tables, and moved to the folder [" & strFolder & "Temp\Missing_table_database\].")
						oLogFile.WriteLine("===============================================================================")			
					End If	
				End If			
										
				If not bFound Then
						oLogFile.WriteLine("Database Name :" & objMDB.Name & ", " & "Missing table name :" & amTables(i,2) )
						bMissingTableMDB=True
				Else
						bFound=False	
				End If				
				
		Next

		If bMissingTableMDB Then
				aDatabase(j)=objMDB.Name
				j=j+1
				ReDim Preserve aDatabase(j)
				bMissingTableMDB=False
				oLogFile.WriteLine("")
		End If 
			
		appAccess.CloseCurrentDatabase					
Next

For i=0 to UBound(aDatabase)-1
		'Move database with missing tables to "...\Missing_table_database" folder
		If objFS.FileExists("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\Unzip_files\" & aDatabase(i)) Then
			Set objFile=objFS.GetFile("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\Unzip_files\" & aDatabase(i))		
			objFile.Copy (strFolder & "Missing_table_database\" & aDatabase(i))
			objFile.Delete()
		End If	
Next
For i=0 to UBound(aDatabase)-1
		sTemp = Left(aDatabase(i),Len(aDatabase(i)) - 3) & "ZIP"
		'Move database with missing tables to "...\Missing_table_database" folder
		If objFS.FileExists("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\zip_files\" & aDatabase(i)) Then
				Set objFile=objFS.GetFile("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\zip_files\" & aDatabase(i))		
				objFile.Delete()
		End If	
		If objFS.FileExists("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\zip_files\" & sTemp ) Then
				Set objFile=objFS.GetFile("C:\SMIRHEBDO_INTERMED_CENTRAL\MERGE_IMPORT\zip_files\" & sTemp )
				objFile.Copy (strFolder & "Missing_table_database\" & sTemp )		
				objFile.Delete()
		End If			
Next



oTSMergeSetupFile.Close
Set objMDB=Nothing
Set objFS = Nothing
Set objFile = Nothing
Set oTSMergeSetupFile = Nothing
Set oLogFile = Nothing
Set objTable = Nothing
Wscript.Quit
